# TP4 MNI cm3 2015-2016
#
# Probleme : max valeur propre et vecteur propre correspondant
# Methode : puissance iteree
# Test : matrice A 4x4 (voir plus bas)
# Solution : lambda=17.11054
# x=[ - 0.5465138 - 0.3111240 - 0.6433598 - 0.4365922 ]


import numpy as np


def PI(n,A,x0,eps):

# initialisation
  q0=np.zeros(n)
  q=np.zeros(n)
  x=np.zeros(n)
  norm=0.
  lamb0=0.
  lamb=0.

# normalisation du vecteur par une norme euclidienne
  norm=np.sqrt(np.dot(x0,x0))
  q0=x0/norm
#  print("Vecteur initial normalise (norme 2):")
#  print(q0)

# methode de la puissance iteree
  it=1
  x=np.dot(A,q0)
# Valeur propre: quotient de Rayleigh
  lamb0=np.dot(q0,x)/(np.dot(q0,q0))
  normx=np.sqrt(np.dot(x,x))
  q=x/normx
# precision initialisee de facon a entrer dans la boucle "tant que"
  prec=2*eps
  while prec>eps: 
    it=it+1
    x=np.dot(A,q)
# Valeur propre: quotient de Rayleigh
    lamb=np.dot(q,x)/(np.dot(q,q))
    prec=abs(lamb-lamb0)
    lamb0=lamb
    normx=np.sqrt(np.dot(x,x))
    q=x/normx

#  print("")
#  print("Solution :")
#  print(" Precision eps = %f" %eps)
#  print(" Nombre d'iterations it = %d" %it)
#  print(" Valeur propre de plus grand module lambda = %f" %lamb)
#  print(" Vecteur propre correspondant: ")
#  print(q)

  return (lamb,q)

