# TP4 MNI cm3 2015-16
#
# Probleme : Solution d'une equation differentielle ordinaire
# Methode : Leapfrog

from math import *
import numpy as np
import matplotlib.pyplot as plt
import leapfrog
import euler
import midpoint

print("")
print("===================================================")
print("Solution d''une equation differentielle ordinaire")
print("===================================================")
print("")
#pas integration
h=0.01
# intervalle integration
a=0. 
b=10.
# nombre pas integration
Np=int((b-a)/h)+1

print("===================================================")
print("TEST: mouvement oscillatoire")
#function
def f(x,y,v):
 return -16.*y

# condition initiale
y0=3.
x0=0.
v0=0.
print("Function f(x)=cos(x)cos(y)")
print("Condition initiale: x0=%f; y0=%f" %(x0,y0))
# Integration eq. diff. avec leapfrog
leapfrog.LF(h,Np,x0,y0,v0,f)
print("===================================================")
print("")

print("===================================================")
print("PROBLEM 1")
#function
def f(x,y,v):
 return -4.*y+np.cos(x)

# condition initiale
y0=0.1
x0=0.
v0=1.
print("Function f(x,y) = -4y + cos(x)")
print("Condition initiale: x0=%f; y0=%f; v0=%f" %(x0,y0,v0))
# Integration eq. diff. avec leapfrog
leapfrog.LF(h,Np,x0,y0,v0,f)
# Comparaison: integration eq. diff. avec point au milieu
# condition initiale
y0=0.1
x0=0.
v0=1.
midpoint.MP(h,Np,x0,y0,v0,f)
# Comparaison: integration eq. diff. avec euler
# condition initiale
y0=0.1
x0=0.
v0=1.
euler.E(h,Np,x0,y0,v0,f)
print("===================================================")
print("")

